Subject: Re: [RFC/PATCH] powerpc: Rewrite IO allocation & mapping on powerpc64

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 15 May 2007 06:53:14 +1000

On Mon, 2007-05-14 at 15:50 +0200, Segher Boessenkool wrote:
> >  - Cleanup and separate tracking of the ISA space in the reserved
> >    low 64K of IO space. No ISA -> Nothing mapped there.
> 
> > I now always reserve the first 64K of IO space for the bridge with
> > the ISA bus on it.
> 
> This is wrong -- there are systems with ISA that
> also have PCI devices that require 16-bit legacy
> I/O windows (e.g., systems with the AMD8111 chip,
> like Maple).
> 
> Or do you mean you reserve the low 64k for the PHB?
> That would work in this case, but still not in
> general.  Not sure if we care though.

Yes, if you have an "isa" node, you get a 64k mapping of IO's for your
PHB in the first 64K of IO space (in addition to a full mapping
elsewhere for devices with proper BARs).

If you don't, you don't get that mapping. I might add a call for
platforms to explicitely map those low 64K to a given PCI host though
for platforms who really want it.

Ben.